subroutine CalcEnergy(Pos, M, L, rc, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), dimension(Dim) :: rij, Fij, Posi
    real(8) :: d, Shift1, Shift2, Shift3 
    real(8) :: d2, id2, id6, id12, id10
    real(8) :: rc2
    integer :: i, j, NA, NB	
!f2py intent(in, out, inplace) :: Forces
    real(8), parameter :: k = 3000., r0 = 1., lambda1=0.2, lambda2=20.
    PEnergy=0.
    !Forces=0.
    Shift1=-4.*(rc**(-12)-rc**(-6))
    Shift2=-4.*lambda1*(rc**(-12)-rc**(-6))
    Shift3=-4.*lambda2*(rc**(-12)-rc**(-10))
    rc2=rc*rc
    NA=NAtom/2
    NB=NAtom/2
do i=0, NAtom
	Posi=Pos(i,:)
	do j=i+1, NAtom-1
		if (j==i+1 .and. mod(j,M) > 0) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d=sqrt(sum(rij*rij))
			PEnergy=PEnergy+(k*0.5)*(d-r0)**(2)
		else if (mod(i,M)==0 .and. mod(j,M)==0) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id10=id2*id2*id2*id2*id2
			id12=id10*id2
			PEnergy=PEnergy+4.*lambda2*(id12-id10)+Shift3
		else if (i<NA .and. j>=NA) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id6=id2*id2*id2
			id12=id6*id6
			PEnergy=PEnergy+4.*lambda1*(id12-id6)+Shift2
		else
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id6=id2*id2*id2
			id12=id6*id6
			PEnergy=PEnergy+4.*(id12-id6)+Shift1	 
		endif
	enddo
enddo
end subroutine

subroutine CalcEnergyForces(Pos, M, L, rc, PEnergy, Forces, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, rc
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
    real(8), dimension(Dim) :: rij, Fij, Posi
    real(8) :: d, Shift1, Shift2, Shift3 
    real(8) :: d2, id2, id6, id12, id10
    real(8) :: rc2
    integer :: i, j, NA, NB	
!f2py intent(in, out, inplace) :: Forces
    real(8), parameter :: k = 3000., r0 = 1., lambda1=0.2, lambda2=20.
    PEnergy=0.
    Forces=0.
    Shift1=-4.*(rc**(-12)-rc**(-6))
    Shift2=-4.*lambda1*(rc**(-12)-rc**(-6))
    Shift3=-4.*lambda2*(rc**(-12)-rc**(-10))
    rc2=rc*rc

    NA=NAtom/2
    NB=NAtom/2
do i=0, NAtom
	Posi=Pos(i,:)
	do j=i+1, NAtom-1
		if (j==i+1 .and. mod(j,M) > 0) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d=sqrt(sum(rij*rij))
			PEnergy=PEnergy+(k*0.5)*(d-r0)**(2)
			Fij=k*(1-r0/d)*rij
			Forces(i,:)=Forces(i,:)+Fij
			Forces(j,:)=Forces(j,:)-Fij
		else if (mod(i,M)==0 .and. mod(j,M)==0) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id10=id2*id2*id2*id2*id2
			id12=id10*id2
			PEnergy=PEnergy+4.*lambda2*(id12-id10)+Shift3
			Fij=4.*lambda2*rij*((-12.*id12+10.*id10)*id2)
			Forces(i,:)=Forces(i,:)+Fij
			Forces(j,:)=Forces(j,:)-Fij
		else if (i<NA .and. j>=NA) then
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id6=id2*id2*id2
			id12=id6*id6
			PEnergy=PEnergy+4.*lambda1*(id12-id6)+Shift2
			Fij=rij*((-48.*id12+24.*id6)*id2)*lambda1
			Forces(i,:)=Forces(i,:)+Fij
			Forces(j,:)=Forces(j,:)-Fij
		else
			rij=Pos(j,:)-Posi
			rij=rij-L*dnint(rij/L)
			d2=sum(rij*rij)
			if (d2>rc2) then
				cycle
			endif
			id2=1./d2
			id6=id2*id2*id2
			id12=id6*id6
			PEnergy=PEnergy+4.*(id12-id6)+Shift1
			Fij=rij*((-48.*id12+24.*id6)*id2)
			Forces(i,:)=Forces(i,:)+Fij
			Forces(j,:)=Forces(j,:)-Fij	 
		endif
	enddo
enddo
end subroutine

subroutine HistogramAA(Pos, L, M, count, NBins, Dim, NAtom)
	implicit none
	real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
	real(8), intent(in) :: L
	integer, intent(in) :: NBins, Dim, NAtom, M
	integer, intent(inout), dimension(0:NBins-1) :: count
!f2py intent(in,out,inplace) :: count
	real(8), dimension(Dim) :: Posi, rij
	integer :: i,j, k, NA,NB
	real(8) :: delta,d
	NA=NAtom/2
	NB=NAtom/2
	delta=real(L)/real(NBins)
do i=0, NA-1
	Posi=Pos(i,:)
		do j=i+1, NA-1	
			if (mod(i,M)/=0 .and. mod(j,M)/=0) then
				rij=Pos(j,:)-Posi
				rij=rij-L*dnint(rij/L)
				d=sqrt(sum(rij*rij))
				do k=0, NBins-1
					if (d < (delta*(k+1)) .and. delta*k <= d) then
						count(k)=count(k)+1
					end if
				enddo	
			end if
		enddo
enddo
end subroutine

subroutine HistogramBB(Pos, L, M, count, NBins, Dim, NAtom)
	implicit none
	real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
	real(8), intent(in) :: L
	integer, intent(in) :: NBins, Dim, NAtom, M
	integer, intent(inout), dimension(0:NBins-1) :: count
!f2py intent(in,out,inplace) :: count
	real(8), dimension(Dim) :: Posi, rij
	integer :: i,j, k, NA,NB
	real(8) :: delta,d
	NA=NAtom/2
	NB=NAtom/2
	delta=real(L)/real(NBins)
do i=NA, NAtom-1
	Posi=Pos(i,:)
		do j=i+1, NAtom-1	
			if (mod(i,M)/=0 .and. mod(j,M)/=0) then
				rij=Pos(j,:)-Posi
				rij=rij-L*dnint(rij/L)
				d=sqrt(sum(rij*rij))
				do k=0, NBins-1
					if (d < (delta*(k+1)) .and. delta*k <= d) then
						count(k)=count(k)+1
					end if
				enddo	
			end if
		enddo
enddo
end subroutine
					
subroutine HistogramCC(Pos, L, M, count, NBins, Dim, NAtom)
	implicit none
	real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
	real(8), intent(in) :: L
	integer, intent(in) :: NBins, Dim, NAtom, M
	integer, intent(inout), dimension(0:NBins-1) :: count
!f2py intent(in,out,inplace) :: count
	real(8), dimension(Dim) :: Posi, rij
	integer :: i,j, k, NA,NB
	real(8) :: delta,d
	NA=NAtom/2
	NB=NAtom/2
	delta=real(L)/real(NBins)
do i=0, NAtom-1
	Posi=Pos(i,:)
		do j=i+1, NAtom-1	
			if (mod(i,M)==0 .and. mod(j,M)==0) then
				rij=Pos(j,:)-Posi
				rij=rij-L*dnint(rij/L)
				d=sqrt(sum(rij*rij))
				do k=0, NBins-1
					if (d < (delta*(k+1)) .and. delta*k <= d) then
						count(k)=count(k)+1
					end if
				enddo	
			end if
		enddo
enddo
end subroutine

subroutine vvintegrate(Pos, Vel, Accel, M, L, rc, dt, KEnergy, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: M, Dim, NAtom
    real(8), intent(in) :: L, rc, dt
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Pos, Vel, Accel
!f2py intent(in,out,inplace) :: Pos, Vel, Accel
    real(8), intent(out) :: KEnergy, PEnergy
    external :: CalcEnergyForces
    Pos = Pos + dt * Vel + 0.5 * dt*dt * Accel
    Vel = Vel + 0.5 * dt * Accel
    call CalcEnergyForces(Pos, M, L, rc, PEnergy, Accel, Dim, NAtom)
    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * sum(Vel*Vel)
end subroutine